//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2
#property indicator_level1  0.7
#property indicator_level2 -0.7
#property indicator_minimum -1
#property indicator_maximum  1

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int                SMAfast   =  5;
extern int                SMAslow   = 55;
extern ENUM_MA_METHOD     MaMethod  = MODE_EMA;
extern ENUM_APPLIED_PRICE Price     = PRICE_CLOSE;

double TrendBuffer[];
string indicatorFileName;
bool   returnBars;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,TrendBuffer);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" TrendPower("+SMAfast+")");
   return(0);
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { TrendBuffer[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));

   //
   //
   //
   //
   //  
 
   for(int i = limit; i>=0 ; i--)
	{
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      double maf = iMA(NULL,TimeFrame,SMAfast,0,MaMethod,Price,y);
      double mas = iMA(NULL,TimeFrame,SMAslow,0,MaMethod,Price,y);
      double atf = iATR(NULL,TimeFrame,SMAfast,y);
      double ats = iATR(NULL,TimeFrame,SMAslow,y);
      if (ats!=0)
	        double MAValue = 100.0*(maf-mas)*atf/mas/ats;
      else        MAValue = 0; 
	   TrendBuffer[i]=(MathExp(2*MAValue)-1)/(MathExp(2*MAValue)+1);
   }
	return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}